"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CoverageSummary(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "COSMIC30Xcov",
        "localRMSD",
        "mean",
        "median",
        "n",
        "pct25",
        "pct75",
        "scope",
        "sd",
        "wellId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.CoverageSummary": reports_2_1_0.CoverageSummary,
        }

    __slots__ = [
        "COSMIC30Xcov",
        "localRMSD",
        "mean",
        "median",
        "n",
        "pct25",
        "pct75",
        "scope",
        "sd",
        "wellId",
    ]

    def __init__(
        self,
        COSMIC30Xcov,
        localRMSD,
        mean,
        median,
        n,
        pct25,
        pct75,
        scope,
        sd,
        wellId,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.CoverageSummary model.

        :param COSMIC30Xcov:
        :type COSMIC30Xcov: double
        :param localRMSD:
        :type localRMSD: double
        :param mean:
        :type mean: double
        :param median:
        :type median: double
        :param n:
        :type n: double
        :param pct25:
        :type pct25: double
        :param pct75:
        :type pct75: double
        :param scope:
        :type scope: str
        :param sd:
        :type sd: double
        :param wellId:
        :type wellId: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
